/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.ergebnis.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="ERGEBNIS_LOG_EINTRAG.ErgebnisOrderByPosition",
     query="SELECT o FROM ErgebnisLogEintrag o WHERE o.ergebnis= ?1 ORDER BY o.position",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ERGEBNIS_LOG_EINTRAG.ErgebnisUndArtOrderByPosition",
     query="SELECT o FROM ErgebnisLogEintrag o WHERE o.ergebnis= ?1 AND ergebnisLogEintragArt = ?2 ORDER BY o.position",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "ERGEBNIS_LOG_EINTRAG")
// @javax.persistence.IdClass(ErgebnisLogEintragPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class ErgebnisLogEintrag
implements ErgebnisLogEintragBase
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public ErgebnisLogEintrag() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public ErgebnisLogEintrag(ErgebnisLogEintrag original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "ergebnis_log_eintrag_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "ErgebnisLogEintrag")
    @javax.persistence.TableGenerator(name = "ErgebnisLogEintrag", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "ErgebnisLogEintrag", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient ErgebnisLogEintragPK pkCache;

  @Override
  public ErgebnisLogEintragPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new ErgebnisLogEintragPK(getId());
    }

    return pkCache;
  }

  public static <E extends ErgebnisLogEintrag> java.util.Map<ErgebnisLogEintragPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<ErgebnisLogEintragPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends ErgebnisLogEintrag> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedErgebnisLogEintragArt = false;
          hasChangedPosition = false;
          hasChangedText = false;
  
      hasChangedErgebnis = false;
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "ERGEBNIS_LOG_EINTRAG_ART", nullable = ErgebnisLogEintragConstants.ERGEBNIS_LOG_EINTRAG_ART_NULLABLE)
    
  protected de.ivu.elect.business.ergebnis.entity.ErgebnisLogEintragArt ergebnisLogEintragArt =  null;

  @javax.persistence.Transient
  protected boolean hasChangedErgebnisLogEintragArt = false;

  public boolean hasChangedErgebnisLogEintragArt(){
    return hasChangedErgebnisLogEintragArt;
  }
  
  /**
   * 
   *
   * getter for ERGEBNIS_LOG_EINTRAG.ERGEBNIS_LOG_EINTRAG_ART
   */
    @Override   public  de.ivu.elect.business.ergebnis.entity.ErgebnisLogEintragArt getErgebnisLogEintragArt() {
        return ergebnisLogEintragArt;
      }

  /**
   * 
   *
   * setter for ERGEBNIS_LOG_EINTRAG.ERGEBNIS_LOG_EINTRAG_ART
   *
   * @param ergebnisLogEintragArt
   */
  @Override   public void setErgebnisLogEintragArt( de.ivu.elect.business.ergebnis.entity.ErgebnisLogEintragArt ergebnisLogEintragArt) {

       resetTkCache();
                  de.ivu.elect.business.ergebnis.entity.ErgebnisLogEintragArt ergebnisLogEintragArtInternal = ergebnisLogEintragArt;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ergebnisLogEintragArt
      , ergebnisLogEintragArtInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedErgebnisLogEintragArt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("ergebnisLogEintragArt");
      }


      

       this.ergebnisLogEintragArt = ergebnisLogEintragArtInternal;

         }

        
      @javax.persistence.Column(name = "POSITION", nullable = ErgebnisLogEintragConstants.POSITION_NULLABLE, precision=ErgebnisLogEintragConstants.POSITION_PRECISION, scale=ErgebnisLogEintragConstants.POSITION_SCALE)
            
  protected java.lang.Long position =  null;

  @javax.persistence.Transient
  protected boolean hasChangedPosition = false;

  public boolean hasChangedPosition(){
    return hasChangedPosition;
  }
  
  /**
   * 
   *
   * getter for ERGEBNIS_LOG_EINTRAG.POSITION
   */
    @Override   public  java.lang.Long getPosition() {
        return position;
      }

  /**
   * 
   *
   * setter for ERGEBNIS_LOG_EINTRAG.POSITION
   *
   * @param position
   */
  @Override   public void setPosition( java.lang.Long position) {

       resetTkCache();
                  java.lang.Long positionInternal = position;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.position
      , positionInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedPosition |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("position");
      }


      

       this.position = positionInternal;

         }

        
      @javax.persistence.Column(name = "TEXT", nullable = ErgebnisLogEintragConstants.TEXT_NULLABLE, length=ErgebnisLogEintragConstants.TEXT_MAX_LENGTH)
        
  protected java.lang.String text =  null;

  @javax.persistence.Transient
  protected boolean hasChangedText = false;

  public boolean hasChangedText(){
    return hasChangedText;
  }
  
  /**
   * 
   *
   * getter for ERGEBNIS_LOG_EINTRAG.TEXT
   */
    @Override   public  java.lang.String getText() {
        return text;
      }

  /**
   * 
   *
   * setter for ERGEBNIS_LOG_EINTRAG.TEXT
   *
   * @param text
   */
  @Override   public void setText( java.lang.String text) {

       resetTkCache();
                  
                          java.lang.String textInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(text, ErgebnisLogEintragConstants.TEXT_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.text
      , textInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedText |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("text");
      }


      

       this.text = textInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Ergebnis
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "ERGEBNIS_ID", referencedColumnName="ERGEBNIS_ID"))
  protected de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis;

  /**
   * 
   */
  @Override
  public void setErgebnis( de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.ergebnis
    , ergebnis);

    attributeChanged |= thisAttributChanged;

    hasChangedErgebnis |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("ergebnis");
    }

    this.ergebnis = ergebnis;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.ergebnis.entity.Ergebnis getErgebnis(){
    return this.ergebnis;
  }

  @javax.persistence.Transient
  protected boolean hasChangedErgebnis = false;

  public boolean hasChangedErgebnis(){
    return hasChangedErgebnis;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("ErgebnisLogEintrag:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(ErgebnisLogEintrag other){
                             other.ergebnisLogEintragArt = this.ergebnisLogEintragArt;
                                other.position = this.position;
                                other.text = this.text;
           
  other.setErgebnis(this.getErgebnis());


  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(ErgebnisLogEintrag.class)){
        copyEntityAttributesUsingSetter((ErgebnisLogEintrag) other.castTo(ErgebnisLogEintrag.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von ErgebnisLogEintrag: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(ErgebnisLogEintrag other){
               other.setErgebnisLogEintragArt(this.ergebnisLogEintragArt);
                  other.setPosition(this.position);
                  other.setText(this.text);
       
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(ErgebnisLogEintrag other){
                       if (hasChangedErgebnisLogEintragArt) {
        other.setErgebnisLogEintragArt(this.ergebnisLogEintragArt);
      }
                             if (hasChangedPosition) {
        other.setPosition(this.position);
      }
                             if (hasChangedText) {
        other.setText(this.text);
      }
             }





    @javax.persistence.Transient
    private transient ErgebnisLogEintragTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public ErgebnisLogEintragTK getErgebnisLogEintragTK(){
    if (tkCache==null) {
    tkCache = new ErgebnisLogEintragTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getErgebnisLogEintragTK();
    }

  @Override
  public ErgebnisLogEintragUK getUk(){
    return getErgebnisLogEintragUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return ErgebnisLogEintrag.class;
  }

public ErgebnisLogEintragUK getErgebnisLogEintragUK(){

   return  new ErgebnisLogEintragUK(



  );
}

  @javax.persistence.Transient
  private transient ErgebnisLogEintragProperties properties;

  public ErgebnisLogEintragProperties getProperties(){
    if (properties == null) {
      properties = new ErgebnisLogEintragProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public ErgebnisLogEintragProperties getErgebnisLogEintragProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return ErgebnisLogEintragConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return false;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
                                 }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                                                                        return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                                                               }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                    return result;
  }

        
            protected String getInitialDiscriminator() {
              return "ERGEBNIS_LOG_EINTRAG";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "ErgebnisLogEintrag";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(ergebnisLogEintragArt, this, ErgebnisLogEintragConstants.MESSAGE_KEY_ERGEBNIS_LOG_EINTRAG_ART_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(position, this, ErgebnisLogEintragConstants.MESSAGE_KEY_POSITION_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(ErgebnisLogEintragConstants.POSITION_MAX_VALUE, ErgebnisLogEintragConstants.POSITION_MIN_VALUE, position, this, ErgebnisLogEintragConstants.MESSAGE_KEY_POSITION_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(text, this, ErgebnisLogEintragConstants.MESSAGE_KEY_TEXT_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(ErgebnisLogEintragConstants.TEXT_MAX_LENGTH , 1 ,  text, this, ErgebnisLogEintragConstants.MESSAGE_KEY_TEXT_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        private transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
